#!/usr/bin/python

# INTRODUCTION TO COMPUTER SCIENCE
# Robert Sedgewick and Kevin Wayne

# This is the syntax highlighted version of PollardRho.java.


# /*************************************************************************
# *  Compilation:  javac PollardRho.java
# *  Execution:    java PollardRho N
# *  
# *  Factor N using the Pollard-Rho method.
# *
# *  % java PollardRho 44343535354351600000003434353
# *  149
# *  329569479697
# *  903019357561501
# *
# *************************************************************************/

# import java.math.BigInteger;
# import java.security.SecureRandom;
    

# class PollardRho {
#     private final static BigInteger ZERO = new BigInteger("0");
#     private final static BigInteger ONE  = new BigInteger("1");
#     private final static BigInteger TWO  = new BigInteger("2");
#     private final static SecureRandom random = new SecureRandom();

#     public static BigInteger rho(BigInteger N) {
#         BigInteger divisor;
#         BigInteger c  = new BigInteger(N.bitLength(), random);
#         BigInteger x  = new BigInteger(N.bitLength(), random);
#         BigInteger xx = x;

#         // check divisibility by 2
#         if (N.mod(TWO).compareTo(ZERO) == 0) return TWO;

#         do {
#             x  =  x.multiply(x).mod(N).add(c).mod(N);
#             xx = xx.multiply(xx).mod(N).add(c).mod(N);
#             xx = xx.multiply(xx).mod(N).add(c).mod(N);
#             divisor = x.subtract(xx).gcd(N);
#         } while((divisor.compareTo(ONE)) == 0);

#         return divisor;
#    }

from random import *

def gcd( a, b ):
    """
    Euclid's algorithm for integer greatest common divisors.
    """

    while b:
        a, b = b, a % b
    return a

def rho( n ):
    c = int( 100 * random( ) )
    x = int( 100 * random( ) )
    c = 17
    x = 19
#    print c, x
    xx = x
    if ( n %  2 == 0):
        return 2
    while ( 1 ) :
        x  = ( x  * x  % n + c ) % n
        xx = ( xx * xx % n + c ) % n
        xx = ( xx * xx % n + c ) % n
        divisor = gcd( n, abs( x - xx ) )
        if divisor != 1:
            break

    print "d: %d" % divisor
    return divisor

#     public static void factor(BigInteger N) {
#         if (N.compareTo(ONE) == 0) return;
#         if (N.isProbablePrime(20)) { System.out.println(N); return; }
#         BigInteger divisor = rho(N);
#         factor(divisor);
#         factor(N.divide(divisor));
#    }
def factor( n ):
    ans = [ ]
    print "%d" % ( n )
    if n == 1:
        print "a: %d" % ( n )
        ans.append( n )
    else:
        divisor = rho( n )
        dividend = n / divisor
        print "b: %d %d" % ( divisor, dividend )
        ans.append( divisor )
        ans.append( factor( dividend ) )
    return ans
 
#     public static void main(String[] args) {
#         BigInteger N = new BigInteger(args[0]);
#         factor(N);
#    }
#}


if __name__ == '__main__':

    import sys
    for i in range( 1, len( sys.argv ) ):
        n = int( sys.argv[ i ])
        f = factor( n )
        print n, f
        
