#!/usr/bin/python

import globals

import TimeStamp

class Result:

    def __init__( self, order, factors, timestamp = None, state = "new" ):
        "Answer a new result item."

        self._p = order
        self._q = 1
        self._factors = factors
        self._state = state
        if timestamp != None:
            self._timestamp = timestamp
        else:
            self._timestamp = TimeStamp.TimeStamp( )

    def type( self ):

        return "Result"

    def __cmp__( self, other ):
        if other == None:
            return 1
        if self._factors == other._factors:
            return 0
        if self._factors > other._factors:
            return 1
        else:
            return -1

    def __hash__( self ):
        return self._factors.__hash__( )

    def __str__( self ):
        if globals.quiet:
            answer = "%d %d  %s" % ( self._p, self._q, self._factors )
        else:
            answer = "%s %4d %2d  %s" % ( self._timestamp, self._p, self._q, self._factors )
        return answer

    def copy( self ):
        "Answer a copy of self."

        result = Result( self.order( ), self.factors( ).copy( ), None, self.state( ) )
        return result

    def factors( self ):
        "Answer the instance variable factors."

        return self._factors

    def matchesFactors( self, factors ):

        return self._factors.matchesFactors( factors )

    def order( self ):
        "Answer instance variable order."

        return self._p

    def state( self, value=None ):
        "Get/Set the instance variable state."

        if value != None:
            self._state = value

        return self._state

    def timeStamp( self ):
        "Answer the instance variable timeStamp."

        return self._timestamp

def FromString( line, state = "old" ):
    import re
    import Factors

    tokens = re.split( " +", line )
    date = "%s %s" % ( tokens[ 0 ], tokens[ 1 ] )
    date = TimeStamp.TimeStamp( date )
    order = int( tokens[ 2 ] )
    power = int( tokens[ 3 ] )

    tokens = re.split( "[()]", line )
    factors = Factors.FromString( tokens[ 1 ] )

    answer = Result( order, factors, date, state )

    return answer

if __name__ == '__main__':
    r = Result( 3, 4 )
    print r.timeStamp( )
