#!/usr/bin/python

import globals

import types
import pydb

import Result

class Ob:

     def __init__( self, val, typ ):
          self._val = val
          self._typ = typ
         
     def __str__( self ):
          return "<Ob  %s, %s>" % ( self._val, self._typ )
         
     def __cmp__( self, other ):
          return self._val - other._val
         
class Ct:
     
     def __init__( self ):
          self._new = 0
          self._dup = 0
          self._old = 0
          
     def __str__( self ):
          answer = "<Ct  new %d, old %d, dup %d>" % ( self._new, self._old, self._dup )
          answer = "    counts:  NEW - %d,  OLD - %d,  DUP - %d, TOT - %d" % \
                   ( self._new, self._old, self._dup, self.tot( ) )
          return answer

     def tot( self ):
          return self._new + self._old + self._dup

     def update( self, str ):
          if str == "new": self._new += 1
          if str == "dup": self._dup += 1
          if str == "old": self._old += 1

class St:

    def __init__( self ):
         self._dict = { }
         self._cntr = Ct( )
          
    def __str__( self ):
         values = self._dict.values( )
         values.sort( )
         answer = "{"
         for value in values:
              answer += " %s" % value
         answer += " }"
         return answer

    def add( self, val ):
         if not isinstance( val, types.StringType ):
              return self.addNum( val )
         else:
              return self.addStr( val )

    def addNum( self, num ):
         obj = self.addObj( Ob( num, "new" ) )
         return obj

    def addStr( self, str ):
         num = int( str )
         obj = Ob( num, "old" )
         obj = self.addObj( obj )
         return obj

    def addObj( self, obj ):
         val = obj._val
         if self._dict.has_key( val ):
              obj = self._dict[ val ]
              typ = obj._typ
              if typ != "new":
                   self._cntr.update( obj._typ )
              obj._typ = "dup"
         else:
              self._dict[ val ] = obj
              if obj._typ != "old":
                   self._cntr.update( obj._typ )
         return obj

def validate( cache, obj, lbl, ref ):
     
    global okcnt, errcnt, verbose

    rslt = "%s" % cache
    if rslt == ref:
         okcnt += 1
         if verbose:
              print "   OK:  %s" % ref
    else:
         errcnt += 1
         print "error:"
         print "  ref:  %s" % ref
         print " rslt:  %s" % rslt
         pydb.debugger( )

def testResultCounter( ):

    global okcnt, errcnt

    okcnt  = 0
    errcnt = 0

    s = St( )
    c = globals.ResultCache            # ResultCache
    s = globals.ResultCache._counts # ResultCounter

    if verbose: print

    o1 = Result.FromString( "07-06-16 09:59:07    2  1  ( 2^1 3^1 )", "new" )
    o2 = Result.FromString( "07-06-16 09:59:07    2  1  ( 2^2 7^1 )" )
    o3 = Result.FromString( "07-06-16 09:59:07    3  1  ( 2^3 3^1 5^1 )", "new" )
    o4 = Result.FromString( "07-06-16 09:59:07    4  1  ( 2^3 3^2 5^1 7^1 13^1 )" )

    o1_n = "o1"
    o2_n = "o2"
    o3_n = "o3"
    o4_n = "o4"

    ob = c.add( o1, o1._state )
    validate( s, ob, o1_n, "    counts:  NEW - 1,  OLD - 0,  DUP - 0, TOT - 1" )
    ob = c.add( o2, "old" ) # r2._state )
    validate( s, ob, o2_n, "    counts:  NEW - 1,  OLD - 0,  DUP - 0, TOT - 1" )
    ob = c.add( o3, o3._state )
    validate( s, ob, o3_n, "    counts:  NEW - 2,  OLD - 0,  DUP - 0, TOT - 2" )
    ob = c.add( o4, o4._state )
    validate( s, ob, o4_n, "    counts:  NEW - 2,  OLD - 0,  DUP - 0, TOT - 2" )

    if verbose: print

    ob = c.add( o4 )
    validate( s, ob, o4_n, "    counts:  NEW - 2,  OLD - 1,  DUP - 0, TOT - 3" )
    ob = c.add( o3 )
    validate( s, ob, o3_n, "    counts:  NEW - 2,  OLD - 1,  DUP - 0, TOT - 3" )
    ob = c.add( o2 )
    validate( s, ob, o2_n, "    counts:  NEW - 2,  OLD - 2,  DUP - 0, TOT - 4" )
    ob = c.add( o1 )
    validate( s, ob, o1_n, "    counts:  NEW - 2,  OLD - 2,  DUP - 0, TOT - 4" )

    if verbose: print

    ob = c.add( o1 )
    validate( s, ob, o1_n, "    counts:  NEW - 2,  OLD - 2,  DUP - 1, TOT - 5" )
    ob = c.add( o3 )
    validate( s, ob, o3_n, "    counts:  NEW - 2,  OLD - 2,  DUP - 2, TOT - 6" )
    ob = c.add( o2 )
    validate( s, ob, o2_n, "    counts:  NEW - 2,  OLD - 2,  DUP - 3, TOT - 7" )
    ob = c.add( o4 )
    validate( s, ob, o4_n, "    counts:  NEW - 2,  OLD - 2,  DUP - 4, TOT - 8" )

    if errcnt == 0:
        print "All %d tests passed" % okcnt
    else:
        print "%d of %d tests passed" % ( okcnt, okcnt + errcnt )
        print "%d of %d tests failed" % ( errcnt, okcnt + errcnt )

if __name__ == '__main__':

    import sys

    verbose = False
    for arg in sys.argv:
        if arg == "v":
            verbose = True

    testResultCounter( )
