#!/usr/bin/python

import re, time

import Number
import Factors
import SigmaFactor
import SigmaFactorCache

verbose = 0

def test_pmcheck_1( p, q, exp ):

    act = SigmaFactor( p, q ).pmcheck( )
    print "a: %s" % act.__class__
    print "e: %s" % exp.__class__
    if act == exp:
        print "test_pmcheck -  %s %s - OK" % ( p, q )
    else:
        print "test_pmcheck error %s %s" % ( p, q )
        print "             act: %s" % act
        print "             exp: %s" % exp

def test_pmcheck( ):
    ok = True

#    pmcheck - OK - 2 ** 47
#                   [2351, 1, 4513, 1, 13264529, 1]


    exp = [ 2351, 1, 4513, 1, 13264529, 1 ]
    exp = Factors.Factors( 2 ** 47 - 1 )
    test_pmcheck_1( 2, 47, exp )

#    pmcheck - OK - 2 ** 48
#                   [7, 1, 3, 2, 65, 1, 4097, 1, 16777217, 1]

    exp = [ 7, 1, 3, 2, 65, 1, 4097, 1, 16777217, 1 ]
    exp = Factors.Factors( 2 ** 48 - 1 )
    test_pmcheck_1( 2, 48, exp )

#    pmcheck - OK - 2 ** 49
#                   [127, 1, 4432676798593, 1]

    exp = [ 127, 1, 4432676798593, 1 ]
    exp = Factors.Factors( 2 ** 49 - 1 )
    test_pmcheck_1( 2, 49, exp )

    print "test_pmcheck complete"

def print_2_3_5_x_3_5_7( ):
    for p in ( 2, 3, 5):
        for q in ( 3, 5, 7):
            print "p,q:  %d,%d" % ( p, q ),
            f = F( p, q )
            s = f.sgmftr( )
            r = f.factor( s )
            print r
    # p,q:  2,3 (3, 1, 5, 1)
    # p,q:  2,5 (3, 2, 7, 1)
    # p,q:  2,7 (3, 1, 5, 1, 17, 1)
    # p,q:  3,3 (2, 3, 5, 1)
    # p,q:  3,5 (2, 2, 7, 1, 13, 1)
    # p,q:  3,7 (2, 4, 5, 1, 41, 1)
    # p,q:  5,3 (2, 2, 3, 1, 13, 1)
    # p,q:  5,5 (2, 1, 3, 2, 7, 1, 31, 1)
    # p,q:  5,7 (2, 3, 3, 1, 13, 1, 313, 1)

def test_2_3_5_x_3_5_7( ):
    ok = True
    ok &= test_p_q_r( 2, 3, [ 3, 1, 5, 1 ] )
    ok &= test_p_q_r( 2, 5, [ 3, 2, 7, 1 ] )
    ok &= test_p_q_r( 2, 7, [ 3, 1, 5, 1, 17, 1 ] )
    ok &= test_p_q_r( 3, 3, [ 2, 3, 5, 1 ] )
    ok &= test_p_q_r( 3, 5, [ 2, 2, 7, 1, 13, 1 ] )
    ok &= test_p_q_r( 3, 7, [ 2, 4, 5, 1, 41, 1 ] )
    ok &= test_p_q_r( 5, 3, [ 2, 2, 3, 1, 13, 1 ] )
    ok &= test_p_q_r( 5, 5, [ 2, 1, 3, 2, 7, 1, 31, 1 ] )
    ok &= test_p_q_r( 5, 7, [ 2, 3, 3, 1, 13, 1, 313, 1 ] )
    print "OK: %s" % ok

def test_p_q_r( p, q, r ):
    a = True
    f = SigmaFactor( p, q )

    o = f.sgmftr_old( )
    print "o: %s" % o.__class__

    n = f.sgmftr( )
    print "n: %s" % n.__class__

    if o != n:
        print "error - o: %s,  n: %s" % ( o, n )
        a = False
#    if r != o:
#        print "error - r: %s,  o: %s" % ( r, o )
#        a = False
#    if r != n:
#        print "error - r: %s,  n: %s" % ( r, n )
#        a = False
    return a

def new_test_q1_q2( q1, q2 ):

    
    n1 = 2 ** q1 - 1
    n2 = 2 ** q2 - 1
    print "%d %d, %d %d, %d" % ( q1, n1, q2, n2, n1 / n2 )
    num = Factors.Factors( n1 )
    den = Factors.Factors( n2 )
    print "  num: %s %s" % ( num.__class__, num )
    print "  den: %s %s" % ( den.__class__, den )
    ans = num / den
    print "  ans: %s %s" % ( ans.__class__, ans )
    
def new_test( ):
    new_test_q1_q2( 8, 4 )
    new_test_q1_q2( 16, 4 )
    new_test_q1_q2( 6, 2 )

if __name__ == '__main__':

    import re, sys, time

    prime = None
    powers = None

    for arg in sys.argv[1:]:

        if arg[0] == "v":
            verbose = True
            continue

        if arg[0] == "p":
            tokens = re.split( "[p.]", arg )
            prime = int( tokens[ 1 ] )
            continue
                
        if arg[0] == "q":
            tokens = re.split( "[q.]", arg )
            min = int( tokens[ 1 ] )
            max = int( tokens[ 2 ] )
            powers = range( min, max )
            continue
                
        if arg == "t":
            arg = "t12"
            continue

        if arg[0] == "t":
            for c in arg[ 1: ]:
                if c == "1":
                    test_2_3_5_x_3_5_7( )
                if c == "2":
                    test_pmcheck( )
            continue

        if arg == "x":
            new_test( )
            continue
            
        if arg == "s":
            o = SigmaFactor( 2, 47 )
            print "%s" % o.value( )
            continue

    beg = time.time( )

    if powers:
        for power in powers :
            b = time.time( )
            if verbose:
                print "%d %d" % ( prime, power )
            r = SigmaFactor.SigmaFactor( prime, power ).pmcheck( )
            f = time.time( )
            if f - b > 1 or power > 40:
                print "time: %4.2f    %s" % ( f - b,  r )

    fin = time.time( )
    if fin - beg > 1:
        print "time: %4.2f" % ( fin - beg )
