#!/usr/bin/python

import os, sys
import re, time, types

import Wheel

def display_values( val, list ):
    str = ""
    for item in list:
        val += item
        if val >= 100:
            break

        if isprime( val ):
            str += "%3d " % val
        else:
            str += "%3d*" % val
            
    return ( val, str )

def display_spokes( spoke_list, wheel_list ):
    result = ""
    order = len( spoke_list )
    result += "o: %d\n" % order
    result += "s: %s\n" % spoke_list
    result += "w: %s\n" % wheel_list

    ( val, str ) = display_values( 1, spoke_list )
    result += str
    while val < 100:
        ( val, str ) = display_values( val, wheel_list )
        result += str
    return result

def isprime( val ):
    p = 2
    while p * p < val:
        if val % p == 0:
            return False
        p += 1
    return True

def test_wheel( max, spokes, wheel ):
    str = ""
    pri = 1
    val = 1
    for s in spokes:
        val += s
        str += " %s" % val
        if not isprime( val ):
            str += "*"
    nl = 50
    while True:
        for s in wheel:
            val += s
            str += " %s" % val
            if not isprime( val ):
                str += "*"
            if val >= nl:
                str += "\n"
                nl += 50
            if val >= max:
                return str

def display_wheel( spoke_list, wheel_list ):
    max = 500
    p = 1
    for s in spoke_list[ : -1 ]:
        p += s

    old_dis = display_spokes( spoke_list, wheel_list )
    old_tst = test_wheel( max, spoke_list, wheel_list )

    wheel = Wheel.Wheel( len( spoke_list ) - 1 )
    print "PrimeGenerator o: %d %d, p: %s, c: %d" % ( len( spoke_list ) - 1, wheel.order( ), wheel.primes( ), wheel.cycle( ) )
    spoke_list = wheel.spokes( )
    wheel_list = wheel.wheel( )
    wheel_list = wheel_list[ len( spoke_list ): ]
    new_dis = display_spokes( spoke_list, wheel_list )
    new_tst = test_wheel( max, spoke_list, wheel_list )

    if old_dis == new_dis:
        print "dis - OK"
    else:
        print "dis - diff"

    if old_tst == new_tst:
        print "tst - OK"
    else:
        print "tst - diff"

    print "pri: ",
    vals = [ ]
    p = 1
    for i in spoke_list[ : -1 ]:
        p += i
        vals.append( p )
        print p,
    spoke_primes = vals
    print
    print

    if old_dis == new_dis and old_tst == new_tst:
        print "s: %s" % spoke_list
        print "w: %s" % wheel_list
        for l in ( 1, 2, 3 ):
            for i in wheel_list:
                p += i
                vals.append( p )
        print vals
    else:
        print "old_dis"
        print old_dis
        print "new_dis"
        print new_dis

        print "old_tst"
        print old_tst
        print "new_tst"
        print new_tst

    print

def Test_PrimeGenerator2( ):
    print "PrimeGenerator 1 2 2"
    primes = [ 2 ]
    spokes = [ 1, 1 ]
    wheel  = [ 2 ]
    display_wheel( spokes, wheel )

def Test_PrimeGenerator6( ):
    print "PrimeGenerator 2 2,3 6"
    primes = [ 2, 3 ]
    spokes = [ 1, 1, 2 ]
    wheel  = [ 2, 4 ]
    display_wheel( spokes, wheel )

#def Test_PrimeGenerator30( ):
#    print "PrimeGenerator 3 2,3,5 30"
#    primes = [ 2, 3, 5 ]
#    spokes = [ 1, 1, 2, 2 ]
#    wheel  = [ 4, 2, 4, 6, 2, 6, 4 ]
#    wheel  = [ 4, 2, 4, 2, 4, 6, 2, 6 ]
#    display_wheel( spokes, wheel )

def Test_PrimeGenerator210( ):
    print "PrimeGenerator 4 2,3,5,7 210"
    primes = [ 2, 3, 5,7 ]
    primes = [ 2, 3, 5, 7, 11 ]
    spokes = [ 1, 1, 2, 2, 4 ]
    wheel  = [ 2, 4, 2, 4, 6, 2, 6, 4,
               2, 4, 6, 6, 2, 6, 4,
               2, 6, 4, 6, 8, 4,
               2, 4, 2, 4, 8, 6, 4,
               6, 2, 4, 6, 2, 6, 6,
               4, 2, 4, 6, 2, 6, 4,
               2, 4, 2, 10, 2, 10 ]
    display_wheel( spokes, wheel )

def main( ):

    for arg in sys.argv[1:]:

        if arg[ 0 ].isdigit( ):
            val = int( arg )

            # [ 2 ]
            if val == 1:
                Test_PrimeGenerator2( )

            # [ 2, 3 ] -> 6
            if val == 2 or val == 6:
                Test_PrimeGenerator6( )

            # [ 2, 3, 5 ] -> 30
            if val == 3 or val == 30:
                Test_PrimeGenerator30( )

            # [ 2, 3, 5, 7 ] -> 210
            if val == 4 or val == 210:
                Test_PrimeGenerator210( )

        if arg[ 0 ] == "p":
            tokens = re.split( "=", arg )
            wheel = Wheel.Wheel( int( tokens[1] ) )
            primes = wheel.spokes( )
            for prime in primes:
                print prime

        if arg[ 0 ] == "w":
            tokens = re.split( "=", arg )
            count = int( tokens[ 1 ] )
            wheel = Wheel.Wheel( count )

            spokes = wheel.spokes( )
            wheel = wheel.wheel( )

            display_spokes( count, spokes, wheel )

            wheel = Wheel.Wheel( count )
            for n in range( 2, 100 ):
                if wheel.isprime( n ):
                    print n,
            print

if __name__ == '__main__':
    main( )
