#!/usr/bin/python

import sys

class Wheel:

    def __init__( self, order ):
        if order != None:
            self._order  = order
            self._spokes = self.generate_spokes( )
            self._wheel  = self.generate_wheel( )
            p = 1
            v = 1
            for spoke in self._spokes:
                v = v * p
                p += spoke
            self._cycle = v

    def type( self ):

        return "Wheel"

    def cycle( self ):
        return self._cycle

    def order( self ):
        return self._order

    def primes( self ):
        return self._primes

    def spokes( self ):
        return self._spokes

    def wheel( self ):
        return self._wheel

    def copy_spokes( self ):
        list = [ ]
        for spoke in self._spokes:
            list.append( spoke )
        return list

    def divides( self, val ):
        for prime in self._primes:
            if val % prime == 0:
                return True
        return False

    def isprime( self, val ):
        factor = 2
        while factor * factor <= val:
            if val % factor == 0:
                return False
            factor += 1
        return True

    def generate_spokes( self ):
        # include 1 prime beyond spoke count
        cnt = 0
        val = 1
        prv = val
        list = [ ]
        self._primes = [ ]

        while cnt <= self._order:
            val += 1
            if self.isprime( val ):
                cnt += 1
                list.append( val - prv )
                prv = val
                if cnt <= self._order:
                    self._primes.append( val )

        return list

    def generate_wheel( self ):
        len = 1
        prime = 1

        for spoke in self._spokes:
            len *= prime
            prime += spoke

        list = self.copy_spokes( )

        prv = prime
        for val in range( prime + 1, prime + len + 1 ):
            if not self.divides( val ):
                dif = val - prv
                list.append( dif )
                prv = val

        return list

def main( ):

    for arg in sys.argv[1:]:

        if arg[ 0 ].isdigit( ):
            val = int( arg )
            w = Wheel( val )
            print "Wheel( %d )" % w.order( )
            print "    p: %s" % w.primes( )
            print "    s: %s" % w.spokes( )
            print "    w: %s" % w.wheel( )

if __name__ == '__main__':
    main( )
