#!/usr/bin/env python

'''
http://sourceforge.net/project/showfiles.php?group_id=179216&package_id=206981&release_id=611735
'''

import pyecm
import math
import sys, time
import Number
import TimeStamp

def dict_from_list( list ):

    for prime in list:
        power = result.get( prime, 0 ) +  1
        result[ prime ] = power
    return result

def sgmftr( p, q ):
    result = ( p ** ( q + 1 ) - 1 ) / ( p - 1 )
    return result

def factors_as_dict( n ):
    ra = veb = False
    pr = 1.0

    ov = 2*math.log(math.log(n))

    result = { } # dict
    for factor in pyecm.factors(n, veb, ra, ov, pr):
        power = result.get( factor, 0 ) +  1
        result[ factor ] = power

    return result

def factors_as_dict_of_numbers( n ):
    ra = veb = False
    pr = 1.0

    ov = 2*math.log(math.log(n))

    result = { } # dict
    for factor in pyecm.factors(n, veb, ra, ov, pr):
        if not result.has_key( factor ):
            power = 1
        else:
            power = result[ factor ].power( ) +  1
        result[ factor ] = Number.Number( factor, power )

    return result

def print_factors( p, q, factors ):
    print "%d  %d " % ( p, q ),
    print "(",
    keys = factors.keys( )
    keys.sort( )
    for p in keys:
        q = factors [ p ]
        print "%s^%s" % (p, q) ,
    print ")"

def print_sgmftr( p, q ):
    '''
    print start time & sgmftr( p, q )
    print finish time & factors
    '''

    n = sgmftr( p, q )

    s = TimeStamp.TimeStamp( )
    print "%s    %d  %d  %e  %d" % ( s, 2, q, n * 1.0, n )
    sys.stdout.flush( )

    factors = factors_as_dict( n )

    s = TimeStamp.TimeStamp( )
    print "%s   " % s,
    print_factors( 2, q, factors )
    sys.stdout.flush( )

def time_sgmftr( p, q ):
    '''
    print start time & sgmftr( p, q )
    print elapsed time & factors
    '''

    n = sgmftr( p, q )

    b = time.time( )
    t = hhmmss( time.localtime( b ) )
    print "%s    %d  %d  %e  %d" % ( t, 2, q, n * 1.0, n )
    sys.stdout.flush( )

    factors = factors_as_dict( n )

    f = time.time( )
    t = hhmmss( f -  b )
    print "%s   " % t,
    print_factors( 2, q, factors )
    sys.stdout.flush( )

def do_test( ):

    if argc < 3:
        min = 2
        max = 200
    else:
        min = int( sys.argv[ 2 ] )
        max = int( sys.argv[ 3 ] )
    
    for q in range( min, max ) :
        print_sgmftr( 2, q )

def do_time( ):

    if argc < 3:
        min = 2
        max = 200
    else:
        min = int( sys.argv[ 2 ] )
        max = int( sys.argv[ 3 ] )
    
    for q in range( min, max ) :
        time_sgmftr( 2, q )

def do_args( ):

    for i in range( 1, len( sys.argv ) / 2 ):
        p = int( sys.argv[ i * 2 ] )
        q = int( sys.argv[ i * 2 + 1 ] )
        
        print_sgmftr( p, q )

if __name__ == '__main__':
    argc = len( sys.argv )

    if sys.argv[ 1 ] == 'test':
        do_test( )
    elif sys.argv[ 1 ] == 'time':
        do_time( )
    else:
        do_args( )
